const state = {
  searchParams: {
    // [route.path]: { ...searchContent }
  }
}

const mutations = {
  SET_SEARCH_PARAMS: (state, config) => {
    if (!config || typeof config !== 'object') { return }
    if (!config.path) { return }
    if (config.param && typeof config.param === 'object' && Object.keys(config.param).length > 0) {
      state.searchParams[config.path] = JSON.stringify(config.param)
    } else {
      delete state.searchParams[config.path]
    }
  },
  RSET_SEARCH_PARAMS: (state) => {
    state.searchParams = {}
  },
  CLEAR_ONE_PARAMS: (state, path) => {
    // path && state.searchParams[path] && delete state.searchParams[path]
    state.searchParams[path] = ''
  }
}

const actions = {
  searchParamsSet({ commit }, config) {
    if (!config || typeof config !== 'object') { return }
    if (!config.path) { return }
    commit('SET_SEARCH_PARAMS', config)
  },
  restSearchParams({ commit }) {
    commit('RSET_SEARCH_PARAMS')
  },
  clearOneParams({ commit }, path) {
    // 延时清除缓存数据，防止路由离开前重新赋值
    setTimeout(() => {
      commit('CLEAR_ONE_PARAMS', path)
    }, 1000)
  }
}

export default {
  namespaced: true,
  state,
  mutations,
  actions
}
